library telcisconv;

uses
  SysUtils,
  uPravidlaPrevodu in 'uPravidlaPrevodu.pas';

{$R *.res}

{-pomocne funkce---------------------------------------------------------------}

function Str_First(Kolik: Integer; Vstup:String):String;
var I:Integer;
begin
  Result:= '';
  if (Length(Vstup) > Kolik)
  then for I:=1 to Kolik do
         Result:=Result+Vstup[I]
  else Result:= Vstup;
end;

function Str_PoZnak(Znak:Char; Vstup: String):String;
var I:Integer;
begin
  Result:='';
  for I:=1 to Length(Vstup) do
  begin
    if Vstup[I]<>Znak then Result:=Result+Vstup[I];
    if Vstup[I]=Znak then Break;
  end;
end;

{-interni funkce prevodu-------------------------------------------------------}

{platne pravidlo[Pravidlo,1]}
function PlatnePravidloPredvolba(CisloPravidla: Integer; StareCislo: ShortString): Boolean;
begin
  if Str_First(Length(Pravidlo[CisloPravidla, 1]), StareCislo)=Pravidlo[CisloPravidla, 1]
    then Result:= True
    else Result:= False;
end;

{platne pravidlo[Pravidlo,2]}
function PlatnePravidloStareCislo(CisloPravidla: Integer; StareCislo: ShortString): Boolean;
var CastPravidlo, CastCislo: String;
begin
  CastPravidlo:= Str_PoZnak('x', Pravidlo[CisloPravidla, 2]);
  CastCislo:= Copy(StareCislo, Length(Pravidlo[CisloPravidla, 1])+1, Length(CastPravidlo));
  if CastPravidlo=CastCislo
    then Result:= True
    else Result:= False;
end;

{zjisti cislo pravidla pro prevod}
function ZjistiCisloPravidla(StareCislo: ShortString): Integer;
var Hledej: Boolean;
    CisloPravidla: Integer;
begin
  Hledej:= True;
  CisloPravidla:= 0;
  while (Hledej) and (CisloPravidla<PMax) do
    begin
      CisloPravidla:= CisloPravidla + 1;
      Hledej:= not((PlatnePravidloPredvolba(CisloPravidla, StareCislo)) and (PlatnePravidloStareCislo(CisloPravidla, StareCislo)));
    end;
  if Hledej
    then Result:= 0
    else Result:= CisloPravidla;
end;

{prevod stareho cisla na nove}
function PrevodPomociPravidla(CisloPravidla: Integer; StareCislo: ShortString): ShortString;
var DelkaKopie: Integer;
    TmpI: Integer;
    PravidloStareCislo: ShortString;
begin
  {zjisti delku kopie}
  DelkaKopie:= 0;
  PravidloStareCislo:= Pravidlo[CisloPravidla, 2];
  for TmpI:= 1 to Length(PravidloStareCislo)
    do begin
      if PravidloStareCislo[TmpI]='x'
        then DelkaKopie:= DelkaKopie + 1;
    end;
  {vyrob vysledne cislo}
  Result:= Str_PoZnak('x', Pravidlo[CisloPravidla, 3]) +
           Copy(StareCislo, Length(StareCislo)-DelkaKopie+1, DelkaKopie);
end;

{hlavni funkce prevodu}
function PrevedCislo(StareCislo: ShortString): ShortString;
var PouzitCisloPravidla: Integer;
    PokracovatVPrevodu: Boolean;
begin
  PokracovatVPrevodu:= True;

  {specialni cislo 060x}
  if Str_First(3, StareCislo)='060'
    then begin
      PokracovatVPrevodu:= False;
      Result:= Copy(StareCislo, 2, 9);
    end;

  {specialni cislo 07}
  if Str_First(2, StareCislo)='07'
    then begin
      PokracovatVPrevodu:= False;
      Result:= Copy(StareCislo, 2, 9);
    end;

  {specialni cislo 08}
  if Str_First(2, StareCislo)='08'
    then begin
      PokracovatVPrevodu:= False;
      Result:= Copy(StareCislo, 2, 9);
    end;

  {specialni cislo 08}
  if Str_First(2, StareCislo)='08'
    then begin
      PokracovatVPrevodu:= False;
      Result:= Copy(StareCislo, 2, 9);
    end;

  {neni to specialni cislo, takze normalni prevod}
  if PokracovatVPrevodu
    then begin
      PouzitCisloPravidla:= ZjistiCisloPravidla(StareCislo);
      if PouzitCisloPravidla=0
        then Result:= StareCislo
        else Result:= PrevodPomociPravidla(PouzitCisloPravidla, StareCislo);
    end;
end;

{-exportovane funkce-----------------------------------------------------------}

{jednina viditelna funkce knihovny, interface prevodu}
function PrevedTelefonniCislo(StareCislo: ShortString): ShortString; stdcall;
begin
  {stare je rovnou nove nebo nejde prevest}
  Result:= StareCislo;

  {stare cislo ma 9 mist, musi se pridat 0 na zacatek}
  if Length(StareCislo)=9
    then begin
      StareCislo:= '0' + StareCislo;
      Result:= PrevedCislo(StareCislo);
    end;

  {stare cislo ma 10 a 0 musi byt na prvnim miste}
  if Length(StareCislo)=10
    then begin
      if StareCislo[1]='0'
        then Result:= PrevedCislo(StareCislo);
    end;
end;

exports
  PrevedTelefonniCislo;

begin
  {zadny kod neni treba}
end.
